#include <stdio.h>

char* Charger(const char* fic,int* taille)
{
	char* res;
	FILE* F = fopen(fic,"rb");
	*taille = 0;
	if (!F)
		return NULL;
	fseek(F,0,SEEK_END);
	*taille = ftell(F);
	fseek(F,0,SEEK_SET);
	res = malloc(*taille);
	fread(res,*taille,1,F);
	fclose(F);
	return res;
}

int Sauver(const char* fic,char* memoire,int taille)
{
	FILE* F = fopen(fic,"wb");
	if (!F)
		return -1;
	fwrite(memoire,taille,1,F);
	fclose(F);
	return 0;
}

void Liberer(char* mem)
{
	if (mem)
		free(mem);
}

int main()
{
	char* memoire;
	int taille;
	memoire = Charger("01_01_06_chargersauver.c",&taille);
	// memoire est un tableau dynamique, modifie ce que tu veux
	Sauver("copie.c",memoire,taille);
	Liberer(memoire);
	return 0;
}


/*!F 
	Voici comment lire tout un fichier d'un seul coup dans un tableau, et le rcrire, ce qui fera une copie du fichier.
	
	Si vous lancez le programme (avec le fichier 01_01_06_chargersauver.c dans le rpertoire de travail, a va le copier comme "copie.c"
	Mais vous pouvez mettre le fichier que vous voulez (mme un EXE, un AVI, ce que vous voulez !)

	La fonction Charger va entirement copier le fichier dans le tableau "memoire", et remplir aussi la taille du tableau retourn.

	Pour cela, une mthode simple qui, parat il, pourrait ne pas tre parfaitement exacte sur certains vieux systmes, mais qui ne m'a personnellement jamais pos de soucis :

	On ouvre le fichier en mode "rb" -> trs important, on l'ouvre en binaire. (1)

	Le fseek 0 sur SEEK_END permet de placer le curseur du fichier  la fin. Le ftell qui suit nous dit ou est le curseur, donc finalement, quelle est la taille du fichier.
	Ensuite, on alloue la mmoire qu'il faut, on remet le curseur au dbut avec un fseek 0 sur SEEK_SET, puis avec un seul fread, on lit le fichier en mmoire.

	Un seul fread permet de lire le fichier le plus vite possible. 
	Certains lisent les fichiers octet par octet en appelant taille*fgetc : les performances sont alors effondres.
	Pour avoir de bons accs aux disques, essayez de lire les plus gros blocs possibles avec un seul fread.

	Sortie de la fonciton Charger, vous pouvez modifier le tableau  votre guise....

	Puis on resauve le fichier en mode binaire "wb" avec un seul fwrite pour des performances optimales.

	Note : je pars du principe que vous avez assez de RAM pour contenir tout le fichier en mmoire.

	----------------------------------------------------

	(1) Ouvrir un fichier en binaire permet de considrer chaque octet de la mme manire. Si vous ne l'ouvrez pas en binaire, mais en texte (avec "r") alors il pourra y avoir
	un traitement particulier pour les caractre '\n', qui peut varier d'un OS  l'autre. 
	
	Ainsi, si vous lisez un 0x0D, vous pourrez avoir une lecture implicite d'un 0x0A qui suit, car Certains OS comme Windows ou Mac par exemple codent le '\n' avec 2 octets.
	(tout ceci tant un hritage de vieilles imprimantes....)

	Pareil pour l'criture, crire un 0D pourra implicitement tre suivi d'un 0A si vous crivez en mode "w" (texte).
	Ainsi il y aura plus d'octets que voulu  la fin.

	Donc pour lire et crire du binaire : "rb" et "wb" -> ainsi, pas de traitements particuliers pour un octet spcifique.

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Copier un fichier quelconque en passant par un tableau
titreE: Copy a file using an array
meta: C;fichiers binaires
metaE: C;binary files
desc : Copier un fichier quelconque en passant par un tableau
descE : Copy a file using an array
cle  : fread,fwrite
*/
